/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007-2008. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {

dojo.provide("com.ibm.rational.report.web.cq.app.view.admin.UserCredentialViewer");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("com.ibm.rational.report.web.core.client.internal.UserClient");
dojo.require("com.ibm.rational.report.web.core.app.internal.Util");
dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");
dojo.requireLocalization("com.ibm.rational.report.web.core.app.internal.common", "Messages");
dojo.requireLocalization("com.ibm.rational.report.web.cq.app.serviceability", "Messages");
//dojo.requireLocalization("com.ibm.rational.report.web.cq.app.view.admin", "Messages");

var CommonMessages	    	= dojo.i18n.getLocalization("com.ibm.rational.report.web.core.app.internal.common", "Messages");
var ServiceabilityMessages	= dojo.i18n.getLocalization("com.ibm.rational.report.web.cq.app.serviceability", "Messages");
//var AdminMessages			= dojo.i18n.getLocalization("com.ibm.rational.report.web.cq.app.view.admin", "Messages");
var UserClient				= com.ibm.rational.report.web.core.client.internal.UserClient;
var MessageFormatter		= com.ibm.rational.report.web.core.app.internal.MessageFormatter;
var Util					= com.ibm.rational.report.web.core.app.internal.Util;
var ServiceResponseHandler	= com.ibm.team.repository.web.transport.ServiceResponseHandler;

/**
 * Displays the Change Password view.
 */
dojo.declare(
	"com.ibm.rational.report.web.cq.app.view.admin.UserCredentialViewer",
	[dijit._Widget, dijit._Templated], {
		
	templatePath: dojo.moduleUrl("com.ibm.rational.report.web.cq", "app/view/admin/templates/UserCredentialViewer.html"),
	
	constructor: function(args) {
		this._controller = args.controller;
		this._userName = args.userName;
	},
	
	postCreate: function() {
		/*
		Util.removeChildren(this.pageTitle);
		this.pageTitle.appendChild(document.createTextNode(AdminMessages.USER_CREDENTIAL_PAGE_TITLE));
		
		Util.removeChildren(this.saveButton);
		this.saveButton.appendChild(document.createTextNode(CommonMessages.SAVE_BUTTON_LABEL));
		
		Util.removeChildren(this.closeButton);
		this.closeButton.appendChild(document.createTextNode(CommonMessages.CLOSE_BUTTON_LABEL));
		
		Util.removeChildren(this.nameLabel);
		this.nameLabel.appendChild(document.createTextNode(AdminMessages.USER_CREDENTIAL_NAME_LABEL));
		
		Util.removeChildren(this.passwordLabel);
		this.passwordLabel.appendChild(document.createTextNode(AdminMessages.USER_CREDENTIAL_PASSWORD_LABEL));
		*/
		
		this._msgFormatter = new MessageFormatter(this.messageArea);
		
		this.name.appendChild(document.createTextNode(this._userName));
		this.pageText.appendChild(document.createTextNode("Specify ClearQuest credential for running reports."));
		//this.pageText.appendChild(document.createTextNode(AdminMessages.USER_CREDENTIAL_SPECIFIY_CQ_CREDENTIALS_TO_RUN_CQ_REPORTS));

		var self = this;

		dojo.connect(this.saveButton, "onclick",
			function(e) {
				e.preventDefault();
				self._updateUserCredential();
			}
		);
		
		dojo.connect(this.closeButton, "onclick",
			function(e) {
				e.preventDefault();
				self._exitPage();
			}
		);
		
		this.password.onkeypress = function (e) {
			// If the user hits "Enter" in the password field, submit the data
			if (e.keyCode == 13) {
				e.preventDefault();
				self._updateUserCredential();
			}
		};
	},

	_updateUserCredential: function() {
		var responseHandler = new ServiceResponseHandler(
			this,
			"_exitPage",
			"_postUpdateUserCredentialError");
		
		var args = {
			name: this._userName,
			password: this.password.value
		};
		UserClient.postUpdateUserCredential(responseHandler, args);
	},
	
	_postUpdateUserCredentialError: function(error) {
		this._msgFormatter.displayErrorMessage(ServiceabilityMessages.FAILED_TO_UPDATE_CQ_USER_CREDENTIAL, error);
	},
	
	_exitPage: function() {
		this._controller.clearMainContent();
	}

});

})();